unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, CPL, StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    tvwCPl: TTreeView;
    pnlBottom: TPanel;
    lblDescription: TLabel;
    imgIcon: TImage;
    procedure tvwCPlChange(Sender: TObject; Node: TTreeNode);
    procedure tvwCPlDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure GetCPlInformation;
  public
    { Public declarations }
  end;
  
var
  MainForm: TMainForm;
  
implementation

{$R *.DFM}

// oҦ CPL ɤαxT
procedure TMainForm.GetCPlInformation;
  
  procedure ProcessNode(ANode: TTreeNode);
  var
    hLib        : THandle;              
    CPLProc     : TCPLApplet;            // V CPlApplet 禡禡
    iCount, I   : Integer;              
    NewNode     : TTreeNode;            
    
    // ΨӨoTc
    cplInfo     : TCPLInfo;             
    newCPLInfo  : TNewCPLInfo;          
    
    // O󪺦W١Byzιϥ
    sName, sInfo: array[0..255] of char;
    hAppIcon    : hIcon;                
  begin
    // J CPL , ɦWYO`ID
    hLib := LoadLibrary(PChar(ANode.Text));
    if hLib = 0 then
    begin
      ANode.Text := ANode.Text + ' - Can''t be loaded !!';
      Exit;
    end;
    
    try
      // o CPlApplet 禡}
      CPLProc := TCPLApplet(GetProcAddress(hLib, 'CPlApplet'));
      if @CPLProc = nil then Exit; // Tw CPlApplet 禡
      
      if CPLProc(Handle, CPL_INIT, 0, 0) = 0 then Exit; // l
      
      // o CPL ɤ䴩xƥ
      iCount := CPLProc(Handle, CPL_GETCOUNT, 0, 0);
      
      for I := 0 to iCount - 1 do
      begin
        // e CPL_INQUIRE T, o TCPLInfo c
        FillChar(cplInfo, sizeof(TCPLInfo), 0);
        CPLProc(Handle, CPL_INQUIRE, I, LongInt(@cplInfo));
        
        // q귽JW, yzιϥ
        LoadString(hLib, cplInfo.idName, @sName, 255);
        LoadString(hLib, cplInfo.idInfo, @sInfo, 255);
        hAppIcon := LoadIcon(hLib,
          MAKEINTRESOURCE(cplInfo.idIcon));
        
        // Y@Ȭ CPL_DYNAMIC_RES, h...          
        if (cplInfo.idName = CPL_DYNAMIC_RES) or
          (cplInfo.idInfo = CPL_DYNAMIC_RES) or
          (cplInfo.idIcon = CPL_DYNAMIC_RES) then
        begin
          // e CPL_NEWINQUIRE T, o TNewCPLInfo c
          FillChar(newCPLInfo, sizeof(TNewCPLInfo), 0);
          CPLProc(Handle, CPL_NEWINQUIRE, I, LongInt(@newCPLInfo));
          
          // oW
          if cplInfo.idName = CPL_DYNAMIC_RES then
            StrCopy(sName, newCPLInfo.szName);
          
          // oyz
          if cplInfo.idInfo = CPL_DYNAMIC_RES then
            StrCopy(sInfo, newCPLInfo.szInfo);
          
          // oϥ
          if cplInfo.idIcon = CPL_DYNAMIC_RES then
            hAppIcon := newCPLInfo.hIcon;
        end;
        
        CPLProc(Handle, CPL_STOP, I, cplInfo.lData);
        
        // C@إߤl`I
        StrCat(sName, ' - ');
        StrCat(sName, sInfo);
        NewNode := tvwCPl.Items.AddChild(ANode, sName);
        // Q Data ݩʨxs Icon  Handle
        NewNode.Data := Pointer(hAppIcon);
      end;
      
      CPLProc(Handle, CPL_EXIT, 0, 0);
    finally
      FreeLibrary(hLib); // OѤF CPL 
    end;
  end;
  
var
  sSysDir  : array[0..255] of char; // tΥؿ
  iResult  : Integer;              
  SearchRec: TSearchRec;           
  NewNode  : TTreeNode;            
begin
  GetSystemDirectory(sSysDir, 255); // otΥؿ
  
  // }lMtΥؿU CPL ɮ
  iResult := FindFirst(sSysDir + '\*.CPL', faAnyFile, SearchRec);
  while iResult = 0 do
  begin
    // C@ CPL , Nإ߷s`I, ñN`ID]ɦW
    NewNode := tvwCPl.Items.AddChild(nil,
      AnsiLowerCase(SearchRec.name));
    
    // AIs ProcessNode Bzs`I
    ProcessNode(NewNode);
    // N`Ii}
    NewNode.Expand(True);
    
    // MU@ CPL 
    iResult := FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  
  // ܲĤ@Ӹ`I
  tvwCPl.Selected := tvwCPl.Items.GetFirstNode;
end;

procedure TMainForm.tvwCPlChange(Sender: TObject; Node: TTreeNode);
var
  Num: Integer;
begin
  if Node.Level = 0 then // YI CPL 
  begin
    if Node.HasChildren then // Y]t(l`I)...
      Num := Node.GetLastChild.Index + 1
    else
      Num := 0;
    
    lblDescription.Caption := Format('%s ֦ %d ӱx',
      [Node.Text, Num]);
  end else // YIﱱx
  begin
    lblDescription.Caption := Node.Text;
    // wϥ
    imgIcon.Picture.Icon.Handle := hIcon(Node.Data);
  end;
end;

procedure TMainForm.tvwCPlDblClick(Sender: TObject);
var
  hLib   : THandle;
  CPLProc: TCPLApplet; // V CPlApplet 禡禡
  ANode  : TTreeNode;
  cplInfo: TCPLInfo;   // ΨӨoTc
begin
  ANode := tvwCPl.Selected;
  if (not Assigned(ANode)) or (ANode.Level <> 1) then Exit;

  // J CPL , CPL ɦWY`I`ID
  hLib := LoadLibrary(PChar(ANode.Parent.Text));
  if hLib = 0 then
  begin
    MessageDlg('LkJ' + ANode.Parent.Text, mtError,[mbOK], 0);
    Exit;
  end;

  // o CPlApplet 禡}
  CPLProc := TCPLApplet(GetProcAddress(hLib, 'CPlApplet'));
  if @CPLProc <> nil then
  begin
    // Ұʤ, sYO`I (ANode.Index)
    CPLProc(Handle, CPL_INIT, 0, 0);
    FillChar(cplInfo, sizeof(TCPLInfo), 0);
    CPLProc(Handle, CPL_INQUIRE, ANode.Index, LongInt(@cplInfo));
    CPLProc(Handle, CPL_DBLCLK, ANode.Index, cplInfo.lData);
    CPLProc(Handle, CPL_STOP, ANode.Index, cplInfo.lData);
    CPLProc(Handle, CPL_EXIT, 0, 0);
  end;
  FreeLibrary(hLib); // OF CPL 
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  // oҦ CPL ɤαxT
  GetCPlInformation;
end;

end.

