unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MMSystem, ExtCtrls;

type
  TForm1 = class(TForm)
    pnlCanvas: TPanel;
    btnStart: TButton;
    btnStop: TButton;
    btnCaps: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    cbxResolution: TComboBox;
    txtInterval: TEdit;
    cbxPointNum: TComboBox;
    procedure btnStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btnCapsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  
var
  Form1: TForm1;
  
implementation

{$R *.DFM}

const
  SPEED = 5; { ̤jʳtv }
  
var
  TimerID            : Integer;                { pɾs }
  PointNum           : Integer;                { Iƥ }
  Points, Steps      : array[0..20] of TPoint;
  
  pnlWidth, pnlHeight: Integer;        { xs pnlCanvas eפΰ }
  pnlHandle          : HWND;           { xs pnlCanvas  handle }
  
  { ѦhCpɾϥΪ^I禡 }
procedure TimerProc(uTimerID, uMessage: UINT; dwUser, dw1, dw2:
    DWORD); stdcall;
  
  procedure InvertDirection(var Step: Integer);
  begin
    if Step > 0 then Step := -1 else Step := 1;
    Step := (Random(SPEED) + 1) * Step;
  end;
  
var
  I : Integer;
  DC: HDC;    
  R : TRect;  
begin
  for I := 0 to PointNum - 2 do
  begin
    { sCӺIy }
    Inc(Points[I].X, Steps[I].X);
    Inc(Points[I].Y, Steps[I].Y);

    { PyЬO_WX pnlCanvas d, pGWX, hϦV䲾ʤV,
    ísHüƨotv }
    if (Points[I].X <= 0) or (Points[I].X >= pnlWidth) then
      InvertDirection(Steps[I].X);
    if (Points[I].Y <= 0) or (Points[I].Y >= pnlHeight) then
      InvertDirection(Steps[I].Y);
  end;
  Points[PointNum - 1] := Points[0];
  
  { N pnlCanvas Mզísøs Bezier u }
  DC := GetDC(pnlHandle);
  GetClientRect(pnlHandle, R);
  FillRect(DC, R, GetStockObject(WHITE_BRUSH));
  PolyBezier(DC, Points, PointNum);
  ReleaseDC(pnlHandle, DC);
end;

procedure TForm1.btnStartClick(Sender: TObject);
var
  I: Integer;
begin
  { ]wһݤT }
  if timeBeginPeriod(StrToInt(cbxResolution.Text)) <> TIMERR_NOERROR
    then
  begin
    ShowMessage('Something wrong happened when setting timer period !!');
    Exit;
  end;
  
  btnStart.Enabled := False;
  btnStop.Enabled := True;
  cbxResolution.Enabled := False;
  
  { OU pnlCanvas  handle μeI }
  with pnlCanvas do
  begin
    pnlHandle := Handle;
    pnlWidth := ClientWidth;
    pnlHeight := ClientHeight;
  end;
  
  PointNum := StrToInt(cbxPointNum.Text);
  for I := 0 to PointNum - 2 do
  begin
    { HüƨoCӺIlm }
    Points[I].X := Random(pnlWidth);
    Points[I].Y := Random(pnlHeight);
    
    { HüƨoCӺIʳtvΤV }
    if Random < 0.5 then Steps[I].X := Random(SPEED) + 1 else
      Steps[I].X := - (Random(SPEED) + 1);
    if Random < 0.5 then Steps[I].Y := Random(SPEED) + 1 else
      Steps[I].Y := - (Random(SPEED) + 1);
  end;
  { ̫@IPĤ@IX }
  Points[PointNum - 1] := Points[0];
  
  { ]wpɾ, YJjɶXk, h] 10 @ }
  TimerID := timeSetEvent(StrToIntDef(txtInterval.Text, 10),
    StrToInt(cbxResolution.Text), @TimerProc, 0, TIME_PERIODIC);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  cbxResolution.ItemIndex := 0;
  cbxPointNum.ItemIndex := cbxPointNum.Items.Count - 1;
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
  { Rpɾ }
  timeKillEvent(TimerID);
  { YIs timeBeginPeriod, OobpɾRIs timeEndPeriod, 
    öǤJۦPѼ }
  timeEndPeriod(StrToInt(cbxResolution.Text));
  
  btnStart.Enabled := True;
  btnStop.Enabled := False;
  cbxResolution.Enabled := True;
end;

procedure TForm1.btnCapsClick(Sender: TObject);
var
  Caps: TTimeCaps;
begin
  { oܦhCpɾҤ䴩ѪRפWU }
  if timeGetDevCaps(@Caps, sizeof(TTimeCaps)) = TIMERR_NOERROR then
    ShowMessage('minimum supported resolution: ' +
    IntToStr(Caps.wPeriodMin)
     + #13#10'maximum supported resolution: ' +
    IntToStr(Caps.wPeriodMax))
  else
    ShowMessage('Size of "TTimeCaps" structure error.');
end;




initialization
  Randomize;
end.

