unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    btnFreq: TButton;
    btnCounter: TButton;
    btnStart: TButton;
    btnStop: TButton;
    lblElapseTime: TLabel;
    procedure btnFreqClick(Sender: TObject);
    procedure btnCounterClick(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  
var
  Form1: TForm1;
  
implementation

var
  bStopCounter: Boolean;
  
  {$R *.DFM}
  
procedure TForm1.btnFreqClick(Sender: TObject);
var
  L: TLargeInteger;
begin
  if QueryPerformanceFrequency(L) then
    ShowMessage('Frequency: ' + IntToStr(L))
  else
    ShowMessage('This system doesn''t support high-resolution performance counter !!');
end;

procedure TForm1.btnCounterClick(Sender: TObject);
var
  L: TLargeInteger;
begin
  if QueryPerformanceCounter(L) then
    ShowMessage('Counter: ' + IntToStr(L))
  else
    ShowMessage('This system doesn''t support high-resolution performance counter !!');
end;

procedure TForm1.btnStartClick(Sender: TObject);
var
  Start, L: TLargeInteger;
  Freq    : Integer;
begin
  QueryPerformanceFrequency(L);
  Freq := Round(L / 1000);

  bStopCounter := False;QueryPerformanceCounter(Start);
  repeat
    QueryPerformanceCounter(L);

    lblElapseTime.Caption := Format('Elpased time: %g ms',
      [(L - Start) / Freq]);

    Application.ProcessMessages;
  until bStopCounter or Application.Terminated;
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
  bStopCounter := True;
end;

end.

