unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ExtDlgs, ClipBrd;

type
  TMainForm = class(TForm)
    lblCaption: TLabel;
    lblClassName: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    lblRect: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    lblHandle: TLabel;
    speCapture: TShape;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Button2: TButton;
    ScrollBox1: TScrollBox;
    imgResult: TImage;
    dlgSavePicture: TSavePictureDialog;
    btnCopyToClipBoard: TButton;
    tmrDelay: TTimer;
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure speCaptureMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure btnCopyToClipBoardClick(Sender: TObject);
    procedure tmrDelayTimer(Sender: TObject);
  private
    FCapturing: Boolean;
    
    FOldWnd: HWND;
    procedure GrabImage(Wnd: HWND);
  public
    { Public declarations }
  end;
  
var
  MainForm: TMainForm;
  
implementation

uses xWindows;

{$R *.DFM}

procedure TMainForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
begin
  // ƹ
  ReleaseCapture;
  Screen.Cursor := crDefault;

  if FOldWnd <> 0 then DrawWindowFocusRect(FOldWnd);

  FCapturing := False;
  Caption := Application.Title;
end;

procedure TMainForm.GrabImage(Wnd: HWND);
var
  R, R1      : TRect;  
  DC         : HDC;    
  bOverlapped: Boolean;
begin
  DC := getwindowdc(Wnd);
  GetWindowRect(Wnd, R);
  bOverlapped := IntersectRect(R1, R, BoundsRect);
  MapWindowPoints(HWND_DESKTOP, Wnd, R, 2);
  OffsetRect(R, - R.left, - R.top);
  
  if bOverlapped then WindowState := wsMinimized;
  DrawWindowFocusRect(Wnd);
  with imgResult do
  begin
    Picture.Bitmap.Width := R.right;
    Picture.Bitmap.Height := R.bottom;
    
    BitBlt(Canvas.Handle, 0, 0, R.right, R.bottom, DC, 0, 0, SRCCOPY);
    Refresh;
  end;
  DrawWindowFocusRect(Wnd);
  if bOverlapped then WindowState := wsNormal;
  
  releasedc(Wnd, DC);
end;

procedure TMainForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
    Y: Integer);
var
  Wnd: HWND;                 
  Buf: array[0..255] of char;
  R  : TRect;                
begin
  if not FCapturing then Exit;

  Wnd := FindTopMostWindow(GetDesktopWindow, ClientToScreen(point(X, Y)));
  if (FOldWnd <> Wnd) and (Wnd <> 0) then
  begin
    if FOldWnd <> 0 then DrawWindowFocusRect(FOldWnd);
    DrawWindowFocusRect(Wnd);

    lblHandle.Caption := IntToHex(Wnd, 16);

    getwindowtext(Wnd, Buf, sizeof(Buf));
    lblCaption.Caption := Buf;

    getclassname(Wnd, Buf, sizeof(Buf));
    lblClassName.Caption := Buf;

    GetWindowRect(Wnd, R);
    lblRect.Caption := format('(%d,%d)-(%d,%d) %dx%d',
      [R.left, R.top, R.right, R.bottom, R.right - R.left, R.bottom - R.top]);

    FOldWnd := Wnd;

    // Npɾs}
    tmrDelay.Enabled := False;
    tmrDelay.Enabled := true;
  end;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Caption := Application.Title;
end;

procedure TMainForm.speCaptureMouseDown(Sender: TObject;
    Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Pt: TPoint;
begin
  if Button <> mbLeft then Exit;
  
  FCapturing := true;
  FOldWnd := 0;
  Caption := Application.Title + ' Capturing ...';
  Screen.Cursor := crCross;
  
  // IsoӪ, ҦǨ form  mouse message |ɨ
  // ثe CapturedControl - speCapture ..
  SetCaptureControl(nil);
  // Is SetCapture , DUC, _h|_ƹT
  // 1. Is ReleaseCapture API
  // 2. ϥΪƹΫU䥦ƹ
  SetCapture(Handle);
  
  // Bzثey
  Pt := point(X, Y);
  Pt := ScreenToClient(speCapture.ClientToScreen(Pt));
  FormMouseMove(Self, Shift, X, Y);
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  if dlgSavePicture.Execute then
    imgResult.Picture.savetofile(dlgSavePicture.FileName);
end;

procedure TMainForm.btnCopyToClipBoardClick(Sender: TObject);
begin
  ClipBoard.assign(imgResult.Picture.Bitmap);
end;

procedure TMainForm.tmrDelayTimer(Sender: TObject);
begin
  tmrDelay.Enabled := False;
  GrabImage(FOldWnd);
end;

end.

