unit notefrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

const
  WM_NOTE_CHANGED = WM_APP + 0;
  
type
  TNoteForm = class(TForm)
    mmoNote: TMemo;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mmoNoteKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    procedure AddMyMenuItem;
    
    procedure WMSysCommand(var message: TWMSysCommand); message WM_SYSCOMMAND;
    procedure WMNCLButtonDblClick(var message: TWMNCLButtonDblClk); message WM_NCLBUTTONDBLCLK;
  protected
    procedure CreateWnd; override;
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
  end;
  
var
  NoteForm: TNoteForm;
  
implementation

{$R *.DFM}

const
  SC_CHANGE_CAPTION = 1;
  
  { TNoteForm }
  
procedure TNoteForm.AddMyMenuItem;
var
  SysMenu     : HMENU;        
  MenuItemInfo: TMENUITEMINFO;
begin
  SysMenu := Getsystemmenu(handle, false); // otο handle
  
  MenuItemInfo.cbSize := sizeof(MenuItemInfo);
  MenuItemInfo.fMask := MIIM_TYPE;
  MenuItemInfo.fType := MFT_SEPARATOR; // ju
  InsertMenuItem(SysMenu, DWORD( - 1), True, MenuItemInfo); // [Ju
  
  MenuItemInfo.fMask := MIIM_ID or MIIM_TYPE;
  MenuItemInfo.fType := MFT_STRING; // r
  MenuItemInfo.wID := SC_CHANGE_CAPTION; 
  MenuItemInfo.dwTypeData := 'DD'#9'Alt+C';
  InsertMenuItem(SysMenu, DWORD( - 1), True, MenuItemInfo); // [Jﶵ
end;

constructor TNoteForm.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  
  mmoNote.Color := RGB(255, 255, 123); // w]H
  
  AddMyMenuItem;
end;

procedure TNoteForm.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  
  with Params do
  begin
    // ]wTΩ
    Style := WS_SYSMENU or WS_SIZEBOX or WS_VISIBLE or WS_CLIPSIBLINGS;
    ExStyle := WS_EX_TOOLWINDOW or WS_EX_WINDOWEDGE or WS_EX_NOPARENTNOTIFY;

    // mୱW
    WndParent := HWND_DESKTOP;
  end;
end;

procedure TNoteForm.CreateWnd;
begin
  inherited CreateWnd;

  SetWindowPos(handle, HWND_BOTTOM, 0, 0, 0, 0,
    SWP_NOACTIVATE or SWP_NOSIZE or SWP_NOMOVE or SWP_SHOWWINDOW);
end;

procedure TNoteForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caMinimize;
end;

procedure TNoteForm.WMSysCommand(var message: TWMSysCommand);
begin
  with message do
    case CmdType and $fff0 of
      SC_CHANGE_CAPTION: // ϥΪ̿DDﶵ
      begin
        // ߰ݨçsDD
        Caption := InputBox(Application.Title, 'DD', Caption);
        // qDsܦC
        PostMessage(Application.MainForm.handle, WM_NOTE_CHANGED, 0, 0);
      end
    else inherited;
    end;
end;

procedure TNoteForm.mmoNoteKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = #13) and (Caption = 'New Note') and (mmoNote.Lines.Count > 0) then
  begin
    Caption := mmoNote.Lines[0];
    PostMessage(Application.MainForm.handle, WM_NOTE_CHANGED, 0, 0);
  end;
end;

procedure TNoteForm.FormKeyDown(Sender: TObject; var Key: Word;
    Shift: TShiftState);
begin
  // YU ALT-C ...
  if (Key = Ord('C')) and (ssAlt in Shift) then
    Perform(WM_SYSCOMMAND, SC_CHANGE_CAPTION, 0);
end;

procedure TNoteForm.WMNCLButtonDblClick(var message: TWMNCLButtonDblClk);
begin
  // YDC, PnDDD
  if (message.HitTest = HTCAPTION) then
    Perform(WM_SYSCOMMAND, SC_CHANGE_CAPTION, 0)
  else inherited;
end;

procedure TNoteForm.FormCreate(Sender: TObject);
begin
  Caption := 'New Note'; // w]D
end;

end.

