unit ScreenCanvas;

interface

uses Windows, Graphics;

type
  TScreenCanvas = class(TCanvas)
  private
    procedure FreeContext;
  protected
    procedure CreateHandle; override;
  public
    destructor Destroy; override;
  end;

implementation

destructor TScreenCanvas.Destroy;
begin
  FreeContext;
  inherited Destroy;
end;

procedure TScreenCanvas.CreateHandle;
begin
  Handle := GetDC(0);
end;

procedure TScreenCanvas.FreeContext;
begin
  ReleaseDC(0, Handle);
  Handle := 0;
end;

end.

