unit util;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TMyColor = (ActiveTitle, GradientActiveTitle, Background, Hilight,
    HilightText, TitleText, Window, WindowTextColor, ScrollBar,
    InactiveTitle, GradientInactiveTitle, MenuColor, WindowFrame, MenuText,
    ActiveBorder, InactiveBorder, AppWorkspace, ButtonFace, ButtonShadow,
    GrayText, ButtonText, InactiveTitleText, ButtonHilight, ButtonDkShadow,
    ButtonLight, InfoText, InfoWindow);
  
  TMyCursor = (mcrArrow, mcrHelp, mcrAppStarting, mcrWait, mcrNWPen, mcrNo,
    mcrSizeNS, mcrSizeWE, mcrCrosshair, mcrIBeam, mcrSizeNWSE, mcrSizeNESW,
    mcrSizeAll, mcrUpArrow);
  
  TMySound = (sdDefault, dsAppGPFault, dsMaximize, dsMenuCommand,
    dsMenuPopup, dsMinimize, dsOpen, dsClose, dsRestoreDown, dsRestoreUp,
    dsRingIn, dsRingout, dsSystemAsterisk, dsSystemDefault,
    dsSystemExclamation, dsSystemExit, dsSystemHand, dsSystemQuestion,
    dsSystemStart, dsEmptyRecycleBin);
  
  TMyFont = (mfIcon, mfCaptionFont, mfsmCaptionFont, mfMenuFont,
    mfStatusFont, mfMessageFont);
  
  TMyIcon = (mcMyComputer, mcNeighbor, mcRecycleBinFull,
    mcRecycleBinEmpty);
  
  TMyDesktop = (mdWallPaper, mdBackgroundPattern, mdScreenSaver,
    mdMetrics);
  
const
  secColors        = 'Control Panel\Colors';             
  secCursors       = 'Control Panel\Cursors';            
  secDesktop       = 'Control Panel\Desktop';            
  secMetrics       = 'Metrics';                          
  secBoot          = 'Boot';                             
  
  // tC: ΩtεnΧGyz
  MyColorID: array[TMyColor] of string =
    ('ActiveTitle', 'GradientActiveTitle', 'Background', 'Hilight',
    'HilightText', 'TitleText', 'Window', 'WindowText', 'ScrollBar',
    'InactiveTitle', 'GradientInactiveTitle', 'Menu', 'WindowFrame',
    'MenuText', 'ActiveBorder', 'InactiveBorder', 'AppWorkspace',
    'ButtonFace', 'ButtonShadow', 'GrayText', 'ButtonText',
    'InactiveTitleText', 'ButtonHilight', 'ButtonDkShadow', 'ButtonLight',
    'InfoText', 'InfoWindow');                           
  
  // tCyz
  MyColorDesc: array[TMyColor] of string =
    ('ϥΤDC', 'hϥΤDC', 'ୱ', '',
    'ؤr', 'ϥΤDr', '', 'r', 'b',
    'DϥΤDC', 'hDϥΤDC', '\', '',
    '\r', 'ϥΤ', 'DϥΤ', 'ε{I',
    '骫', 'sv', 'Ǧr', 'sr',
    'DϥΤDr', 'sG', '骫t⳱v', '骫󰪫G',
    'ܤr', '');                                 
  
  // GetSysColor  SetSysColors API ϥ
  MyColorNo: array[TMyColor] of Integer =
    (COLOR_ACTIVECAPTION, COLOR_GRADIENTACTIVECAPTION, COLOR_BACKGROUND,
    COLOR_HIGHLIGHT, COLOR_HIGHLIGHTTEXT, COLOR_CAPTIONTEXT, COLOR_WINDOW,
    COLOR_WINDOWTEXT, COLOR_SCROLLBAR, COLOR_INACTIVECAPTION,
    COLOR_GRADIENTINACTIVECAPTION, COLOR_MENU, COLOR_WINDOWFRAME,
    COLOR_MENUTEXT, COLOR_ACTIVEBORDER, COLOR_INACTIVEBORDER,
    COLOR_APPWORKSPACE, COLOR_BTNFACE, COLOR_BTNSHADOW, COLOR_GRAYTEXT,
    COLOR_BTNTEXT, COLOR_INACTIVECAPTIONTEXT, COLOR_BTNHIGHLIGHT,
    COLOR_3DDKSHADOW, COLOR_3DLIGHT, COLOR_INFOTEXT, COLOR_INFOBK);
  
  // ΩtεnΧGyz
  MyCursorID: array[TMyCursor] of string =
    ('Arrow', 'Help', 'AppStarting', 'Wait', 'NWPen',
    'No', 'SizeNS', 'SizeWE', 'Crosshair', 'IBeam', 'SizeNWSE',
    'SizeNESW', 'SizeAll', 'UpArrow');                   
  
  // SetSystemCursor API ϥ
  MyCursorNO: array[TMyCursor] of Integer =
    (OCR_NORMAL, OIC_QUES, OCR_APPSTARTING, OCR_WAIT, OCR_IBEAM,
    OCR_NO, OCR_SIZENS, OCR_SIZEWE, OCR_CROSS, OCR_IBEAM, OCR_SIZENWSE,
    OCR_SIZENESW, OCR_SIZEALL, OCR_UP);                  
  
  // (}) LoadImage API ϥ, J Windows w]
  MyCursorNo1: array[TMyCursor] of Integer =
    ($64, $70, $6F, $66, $65, $6E, $6C, $6B, $67, $65, $69,
    $6A, $6D, $68);                                      
  
  // ƹдyz
  MyCursorDesc: array[TMyCursor] of string =
    ('@', '', 'u@', 'L', 'r',
    'i', 'վ', 'վ', 'T', 'g', 'uվ 1',
    'uվ 2', '', '䥦');                 
  
  // tέ: ΩtεnΧGyz
  MySoundSect: array[TMySound] of string =
    ('.Default\.Default\.Current', // w]n
    '.Default\AppGPFault\.Current', // {~
    '.Default\Maximize\.Current', // ̤j
    '.Default\MenuCommand\.Current', // \O
    '.Default\MenuPopup\.Current', // \
    '.Default\Minimize\.Current', // ̤p
    '.Default\Open\.Current', // }ҵ{
    '.Default\Close\.Current', // {          
    '.Default\RestoreDown\.Current', // U٭
    '.Default\RestoreUp\.Current', // W٭          
    '.Default\RingIn\.Current', // ӹq              
    '.Default\Ringout\.Current', // ~              
    '.Default\SystemAsterisk\.Current', // P              
    '.Default\SystemDefault\.Current', // SystemDefault     
    '.Default\SystemExclamation\.Current', // n            
    '.Default\SystemExit\.Current', //  Windows      
    '.Default\SystemHand\.Current', // 氱          
    '.Default\SystemQuestion\.Current', // D              
    '.Default\SystemStart\.Current', // Ұ Windows      
    'Explorer\EmptyRecycleBin\.Current');                 // Mzu귽^v
  
  // tέ: Ūtεnnyz
  MySoundDescKey: array[TMySound] of string =
    ('.Default',
    'AppGPFault',
    'Maximize',
    'MenuCommand',
    'MenuPopup',
    'Minimize',
    'Open',
    'Close',
    'RestoreDown',
    'RestoreUp',
    'RingIn',
    'Ringout',
    'SystemAsterisk',
    'SystemDefault',
    'SystemExclamation',
    'SystemExit',
    'SystemHand',
    'SystemQuestion',
    'SystemStart',
    'EmptyRecycleBin');                                  
  
  MyFontDesc: array[TMyFont] of string =
    ('ϥܤr', 'DC', 'OD', '\', 'AC', 'T');
  
  // ୱϥ: ΩtεnΧGyz
  secMyComputer    =
    'CLSID\{20D04FE0-3AEA-1069-A2D8-08002B30309D}\DefaultIcon';
  secNeighbor      =
    'CLSID\{208D2C60-3AEA-1069-A2D7-08002B30309D}\DefaultIcon';
  secRecycleBin    =
    'CLSID\{645FF040-5081-101B-9F08-00AA002F954E}\DefaultIcon';
  
  // ³J Windows 98 beh[F 'Software\Classes\' r
  secMyComputerKey = 'Software\Classes\' + secMyComputer;
  secNeighborKey   = 'Software\Classes\' + secNeighbor;  
  secRecycleBinKey = 'Software\Classes\' + secRecycleBin;
  
  MyIconDesc: array[TMyIcon] of string =
    ('ڪq', 'WھF', '귽^()', '귽^()');
  
  MyDesktopDesc: array[TMyDesktop] of string =
    ('६', 'I˦', 'ùO@', ']w');        

  sInactiveWindow  = 'DϥΤ';
  sActiveWindow    = 'ϥΤ';
  sWindowText      = 'r';
  sMessageBox      = 'T';
  sMessageText     = 'Tr';
  sOK              = 'Tw';
  sHint            = '';

  sNormal          = '`';
  sDisabled        = '';
  sSelected        = 'w';

function NViewLibLoad(FileName: PChar; ShowProgress: Boolean): HBitmap; stdcall; external 'NViewLib.dll';

function StringToBuffer(var S: string; const Buf: Pointer; const Size: Integer): Boolean;
function BufferToString(const Buf: Pointer; const Size: Integer): string;

function CalcForeColor(const mc: TColor): TColor;

function GetMyWallPaperFile: string;

function MyLoadCursor(No: TMyCursor; const FileName: string): HCURSOR;

implementation

uses xStrings, xFiles;

function StringToBuffer(var S: string; const Buf: Pointer; const Size: Integer): Boolean;
var
  I, ByteNo: Integer;
  P        : PByte;  
  sTmp     : string; 
  bExit    : Boolean;
begin
  Result := False;
  
  S := Trim(S); // hkť
  P := PByte(Buf);
  ZeroMemory(P, Size);
  
  ByteNo := 0;
  bExit := False;
  while (ByteNo < Size) and (Length(S) > 0) do
  begin
    if bExit then Exit;
    
    I := Pos(' ', S);
    if I = 0 then bExit := True;
    if bExit then sTmp := S else sTmp := Copy(S, 1, I - 1);
    PByte(Integer(P) + ByteNo)^ := StrToIntDef(sTmp, - 1);
    Delete(S, 1, I);
    Inc(ByteNo);
  end;
  
  if ByteNo = Size then Result := True;
end;

function BufferToString(const Buf: Pointer; const Size: Integer): string;
var
  P: PByte;  
  I: Integer;
begin
  Result := '';
  
  P := PByte(Buf);
  I := 0;
  while I < Size do
  begin
    AppendStr(Result, IntToStr(P^) + ' ');
    Inc(P);
    Inc(I);
  end;
  
  Result := TrimRight(Result);
end;


function CalcForeColor(const mc: TColor): TColor;
begin
  { calculate the Y value (G) of YIQ color model }
  if Round(0.299 * GetRValue(mc) + 0.587 * GetGValue(mc) +
    0.114 * GetBValue(mc)) < 127 then
    Result := clWhite else Result := clBlack;
end;

function GetMyWallPaperFile: string;
var
  Buf: array[0..255] of Char;
begin
  GetWindowsDirectory(@Buf, 255);
  Result := PathWithSlash(StrPas(@Buf)) + 'THEMEMGR.BMP';
end;

function MyLoadCursor(No: TMyCursor; const FileName: string): HCURSOR;
var
  S, Ext: string;
begin
  Result := 0; // ѪܶǦ^ 0
  S := AnsiUpperCase(FileName);

  if FileExists(S) then
  begin
    Ext := ExtractFileExt(S);
    if (Ext = '.CUR') or (Ext = '.ANI') then
    begin
      Result := LoadCursorFromFile(PChar(S));
    end;
  end else if S = '' then // Load windows default cursor (undocumented)
    Result := LoadImage(0, PChar(MyCursorNo1[No]), IMAGE_CURSOR, 0, 0, $240);
end;

end.

