unit savercfg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Registry, Spin, Buttons, ExtCtrls, drawthrd;

type
  TConfigForm = class(TForm)
    pgcConfig: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    gbxMoveSpeed: TGroupBox;
    trbSpeed: TTrackBar;
    gbxDelayTime: TGroupBox;
    lblSpeed: TLabel;
    Label1: TLabel;
    sedDelayTime: TSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    sedChangeDelayTime: TSpinEdit;
    Label4: TLabel;
    Label5: TLabel;
    sedClearDelayTime: TSpinEdit;
    Label6: TLabel;
    mmoEssay: TMemo;
    dlgOpen: TOpenDialog;
    GroupBox4: TGroupBox;
    lbxFiles: TListBox;
    btnAdd: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    btnOK: TButton;
    btnCancel: TButton;
    dlgFont: TFontDialog;
    GroupBox3: TGroupBox;
    btnChatFont: TButton;
    pnlFont: TPanel;
    pbxFont: TPaintBox;
    txtFont: TEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure trbSpeedChange(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lbxFilesClick(Sender: TObject);
    procedure btnChatFontClick(Sender: TObject);
    procedure pbxFontPaint(Sender: TObject);
  private
    FDrawThread: TDrawThread;

    procedure LoadIni;
    procedure SaveIni;
  public
  end;

var
  ConfigForm: TConfigForm;

implementation

{$R *.DFM}

uses util, xfonts;

procedure TConfigForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ModalResult = mrOk then SaveIni;
end;

procedure TConfigForm.trbSpeedChange(Sender: TObject);
begin
  lblSpeed.Caption := Format('%d B',[trbSpeed.Position]);
end;

procedure TConfigForm.LoadIni;
begin
  with TRegIniFile.Create(REGISTRY_KEY) do
    try
      // ]w
      trbSpeed.Position := ReadInteger(SEC_GENERAL, REG_MOVESPEED, 5);
      trbSpeedChange(trbSpeed);
      
      // ܭ
      sedDelayTime.Value := ReadInteger(SEC_GENERAL, REG_MOVEDELAYTIME, 10);
      sedClearDelayTime.Value := ReadInteger(SEC_GENERAL, REG_CLEARDELAYTIME, 10);
      sedChangeDelayTime.Value := ReadInteger(SEC_GENERAL, REG_CHANGEDELAYTIME, 5000);
      
      txtFont.Text := ReadString(SEC_GENERAL, REG_DISPLAYFONT, DEFAULT_DISPLAYFONT);
      
      // uɮ
      ReadSection(SEC_ESSAYFILES, lbxFiles.Items);
    finally
      Free;
    end;
end;

procedure TConfigForm.SaveIni;
var
  I: Integer;
begin
  with TRegIniFile.Create(REGISTRY_KEY) do
    try
      // ]w
      WriteInteger(SEC_GENERAL, REG_MOVESPEED, trbSpeed.Position);
      
      WriteInteger(SEC_GENERAL, REG_MOVEDELAYTIME, sedDelayTime.Value);
      WriteInteger(SEC_GENERAL, REG_CLEARDELAYTIME, sedClearDelayTime.Value);
      WriteInteger(SEC_GENERAL, REG_CHANGEDELAYTIME, sedChangeDelayTime.Value);
      
      // ܭ
      WriteString(SEC_GENERAL, REG_DISPLAYFONT, txtFont.Text);
      
      // uɮ
      EraseSection(SEC_ESSAYFILES);
      with lbxFiles do
        for I := 0 to Items.Count - 1 do
          WriteString(SEC_ESSAYFILES, Items[I], '');
    finally
      Free;
    end;
end;

procedure TConfigForm.btnAddClick(Sender: TObject);
begin
  with dlgOpen, lbxFiles do
    if Execute and (Items.IndexOf(Filename) = -1) then
      case (Sender as TComponent).Tag of
        0: Items.Add(Filename);
        1: Items[ItemIndex] := Filename;
      end;
end;

procedure TConfigForm.BitBtn3Click(Sender: TObject);
begin
  with lbxFiles do
    if ItemIndex <> -1 then
      Items.Delete(ItemIndex);
end;

procedure TConfigForm.FormCreate(Sender: TObject);
begin
  pgcConfig.ActivePage := TabSheet1;
  
  LoadIni;
end;

procedure TConfigForm.lbxFilesClick(Sender: TObject);
begin
  mmoEssay.Lines.LoadFromFile(lbxFiles.Items[lbxFiles.ItemIndex]);
end;

procedure TConfigForm.btnChatFontClick(Sender: TObject);
begin
  StringToFont(txtFont.Text, dlgFont.Font);
  
  if dlgFont.Execute then
  begin
    txtFont.Text := FontTOString(dlgFont.Font);
    pbxFont.Invalidate;
  end;
end;

procedure TConfigForm.pbxFontPaint(Sender: TObject);
begin
  with pbxFont.Canvas do
  begin
    StringToFont(txtFont.Text, Font);
    FillRect(ClipRect);
    
    TextOut(4, 4, 'Hi, oOdҤr');
  end;
end;

end.

