unit util;

interface

uses Windows, Messages;

type
  TSaverMode = (smSaver, smConfig, smPreview);
  
const
  REGISTRY_KEY        = 'Software\Xshadow\XEssaySaver\';
  
  SEC_GENERAL         = 'General';                      
  
  SEC_ESSAYFILES      = 'EssayFiles';                   
  
  REG_MOVESPEED       = 'MoveSpeed';                    
  REG_MOVEDELAYTIME   = 'MoveDelayTime';                
  REG_CLEARDELAYTIME  = 'ClearDelayTime';               
  REG_CHANGEDELAYTIME = 'ChangeDelayTime';              
  
  REG_DISPLAYFONT     = 'DisplayFont';                  
  
  DEFAULT_DISPLAYFONT = '"sө", 11, [], [clWhite]';
  
var
  SaverMode                : TSaverMode;
  ParamHandle, ParentHandle: HWND;      
  
procedure PreviewSaver;

implementation

uses DrawThrd;

function PreviewWndProc(Wnd: HWND; Msg: UINT; WPARAM: Longint;
    LPARAM: Longint): Integer; stdcall;
begin
  case Msg of
    WM_DESTROY:
    begin
      PostQuitMessage(0);
      Result := 0;
    end;
  else
    Result := DefWindowProc(Wnd, Msg, WPARAM, LPARAM);
  end;
end;

procedure PreviewSaver;
const
  PREVIEW_CLASSNAME = 'XEssayScreenSaverPreview';
var
  WndClass: TWndClass;
  MyWnd   : HWND;     
  Msg     : TMsg;     
  R       : TRect;    
begin
  with WndClass do
  begin
    Style := 0;
    lpfnWndProc := @PreviewWndProc;
    cbClsExtra := 0;
    cbWndExtra := 0;
    HICON := 0;
    HInstance := SysInit.HInstance;
    HCURSOR := 0;
    hbrBackground := 0;
    lpszMenuName := nil;
    lpszClassName := PREVIEW_CLASSNAME;
  end;
  
  Windows.RegisterClass(WndClass);
  
  GetWindowRect(ParamHandle, R);
  
  MyWnd := CreateWindow(PREVIEW_CLASSNAME, 'XEssaySaver',
    WS_CHILD or WS_DISABLED or WS_VISIBLE, 0, 0,
    R.Right - R.Left, R.Bottom - R.Top,
    ParamHandle, 0, HInstance, nil);

  with TDrawThread.Create(MyWnd) do // إ߹B@֤߰
  begin
    // Tj
    while GetMessage(Msg, 0, 0, 0) do
    begin
      TranslateMessage(Msg);
      DispatchMessage(Msg);
    end;
    Terminate; // B@֤߰
  end;
  
  { ~UO }
  UnregisterClass(PREVIEW_CLASSNAME, HInstance);
end;

end.

