unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, Menus, StdCtrls, Role;

type
  // |تA, Title e, C, YdιL^U
  TGameStatus = (gsTitle, gsPlaying, gsSuccess, gsPlayback);
  
  TMainForm = class(TForm)
    pnlView: TPanel;
    pbxView: TPaintBox;
    mnuMain: TMainMenu;
    mnuGame: TMenuItem;
    mnuExit: TMenuItem;
    N1: TMenuItem;
    mnuChooseLevel: TMenuItem;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    mnuStartGame: TMenuItem;
    N2: TMenuItem;
    mnuRestart: TMenuItem;
    tmrTimer: TTimer;
    mnuPrevLevel: TMenuItem;
    mnuNextLevel: TMenuItem;
    N3: TMenuItem;
    tmrPlayback: TTimer;
    P1: TMenuItem;
    mnuPlayback: TMenuItem;
    tmrTitle: TTimer;
    procedure pbxViewPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuStartGameClick(Sender: TObject);
    procedure mnuChooseLevelClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuAboutClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuRestartClick(Sender: TObject);
    procedure tmrTimerTimer(Sender: TObject);
    procedure mnuNextLevelClick(Sender: TObject);
    procedure mnuPlaybackClick(Sender: TObject);
    procedure tmrPlaybackTimer(Sender: TObject);
    procedure tmrTitleTimer(Sender: TObject);
  private
    FGameStatus: TGameStatus; // CA
    FLevelNo, FPlayingTime: Integer; // ثedιCiɶ
    FRole: TRole; // ⪫
    
    FBackBitmap: TBitmap; // ΨӰ dobule-buffering  bitmap
    FPlayBackLevelNo: Integer; // iH playback  LevelNo
    
    procedure DrawBackBitmap; // øsI bitmap
    procedure UpdateView; // sCe
    procedure UpdateControlStatus;
    
    // bCeΥWøXrΥ~
    procedure DrawStatusBox(S: string; TopOrCenter: Boolean);
    function CheckFinished: Boolean; // ˬdO_w
    
    procedure SetGameStatus(Value: TGameStatus);
    procedure SetLevelNo(Value: Integer);
    
    property GameStatus: TGameStatus read FGameStatus write SetGameStatus;
    property LevelNo: Integer read FLevelNo write SetLevelNo;
  public
    { Public declarations }
  end;
  
var
  MainForm: TMainForm;
  
implementation

uses util, tiles, Mapunit, about, xFiles;

{$R *.DFM}

procedure TMainForm.UpdateView;
begin
  DrawBackBitmap; // eb bitmap
  pbxView.Canvas.Draw(0, 0, FBackBitmap); // AeW
end;

procedure TMainForm.pbxViewPaint(Sender: TObject);
begin
  UpdateView;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FRole := TRole.Create; // D
  
  Terrs := TTerrTiles.Create; // aιϤθT
  Items := TItemTiles.Create; // ~ϤθT
  
  Map := tmap.Create; // da
  try
    FRole.LoadBits; // ŪJDϧ
    
    Terrs.LoadFromFile(AppDir + FN_TERR_ARCHIVE); // ŪJa
    Items.LoadFromFile(AppDir + FN_ITEM_ARCHIVE); // ŪJ~
  except
    on E: Exception do
      begin
        ShowMessage(E.message);
        PostMessage(Handle, WM_CLOSE, 0, 0); // H asynchronous 覡
      end;
  end;
  
  // According tile num and size, adjust dimension of pnlView
  pnlView.ClientWidth := TILE_WIDTH * TILE_NUM_X;
  pnlView.ClientHeight := TILE_HEIGHT * TILE_NUM_Y;
  
  ClientWidth := pnlView.Width;
  ClientHeight := pnlView.Height;
  
  FBackBitmap := TBitmap.Create; // wĥ bitmap
  FBackBitmap.Width := TILE_WIDTH * TILE_NUM_X;
  FBackBitmap.Height := TILE_HEIGHT * TILE_NUM_Y;
  
  FPlayBackLevelNo := 0; // ثe playback
  FLevelNo := 1;
  
  // wƤu@nF, iJ title e
  GameStatus := gsTitle;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FBackBitmap.Free;
  
  FRole.Free;
  
  Terrs.Free;
  Items.Free;
  
  Map.Free;
end;

procedure TMainForm.DrawBackBitmap;
var
  M, S: Integer;
  Str : string; 
  R   : TRect;  
begin
  Map.DrawTerrMap(FBackBitmap.Canvas); // øsaμh
  Map.DrawItemMap(FBackBitmap.Canvas); // øs~h
  FRole.Draw(FBackBitmap.Canvas); // eXϮ
  
  M := FPlayingTime div 60; // wOɶ
  S := FPlayingTime mod 60; // wOɶ
  with FBackBitmap.Canvas do
  begin
    Font.Color := clWhite;
    Font.name := 'FixedSys';
    Font.Style := [fsBold];
    Font.Size := 14;
    Brush.Style := bsClear;
    
    case FGameStatus of
      gsTitle:
      begin
        // eXWDjrΤU誺@̦W
        R := Rect(0, 0, TILE_WIDTH * TILE_NUM_X, TILE_HEIGHT * TILE_NUM_Y - TextHeight('') div 2);
        DrawText(Handle, '@: eF', - 1, R, DT_BOTTOM or DT_CENTER or DT_SINGLELINE);
        DrawStatusBox('w{ yf', True);
      end;
      
      gsPlayback: TextOut(5, 5, Format('L^U (LEVEL %d) ...',[FLevelNo]));
        
    else
    begin
      // bkWܮɶ, H XX:XX 榡
      Str := Format('%.2d:%.2d',[M, S]);
      TextOut(TILE_WIDTH * TILE_NUM_X - TextWidth(Str) - 5, 5, Str);
      
      // bWd
      Str := Format('LEVEL %d',[FLevelNo]);
      TextOut(5, 5, Str);
    end;
  end;
end;

// oOLe
if FGameStatus = gsSuccess then
  DrawStatusBox('z, \F !!', False);
end;

procedure TMainForm.SetGameStatus(Value: TGameStatus);
begin
  FGameStatus := Value;
  
  // ھڷsCA}Tӭpɾ
  tmrTimer.Enabled := FGameStatus = gsPlaying;
  tmrPlayback.Enabled := FGameStatus = gsPlayback;
  tmrTitle.Enabled := FGameStatus = gsTitle;
  
  case FGameStatus of
    gsTitle: LevelNo := 1; // weܲĤ@a
      
    gsPlaying:
    begin
      FPlayingTime := 0; // pks
      FRole.CleanMoveList; // play back ks
    end;
    
    gsSuccess:
    begin
      // LF, NdO_, ܭnɴN^d
      FPlayBackLevelNo := FLevelNo;
    end;
    
    gsPlayback:
    begin
      LevelNo := FPlayBackLevelNo; // O^Ud
      tmrPlayback.Tag := 0; // qĤ@B}l
    end;
  end;
  
  UpdateControlStatus; // sDCΨ䥦
  UpdateView; // sCe
end;

procedure TMainForm.SetLevelNo(Value: Integer);
begin
  Map.LevelNo := Value;
  FRole.X := Map.Role_X;
  FRole.Y := Map.Role_Y;
  
  FLevelNo := Value;
  UpdateControlStatus;
  UpdateView;
end;

procedure TMainForm.UpdateControlStatus;
const
  StatusStr: array[TGameStatus] of string = ('Welcome', '', 'Congratulation !!', 'Playback');
begin
  if FGameStatus <> gsPlaying then
    Caption := Format('%s - %s',[Application.Title, StatusStr[FGameStatus]])
  else
    Caption := Format('%s - Level %d',[Application.Title, FLevelNo]);
  
  mnuRestart.Enabled := FGameStatus = gsPlaying;
  mnuStartGame.Enabled := FGameStatus <> gsPlaying;
  
  mnuPrevLevel.Enabled := (FGameStatus = gsPlaying) and (LevelNo > 1);
  mnuNextLevel.Enabled := (FGameStatus = gsPlaying);
  
  mnuPlayback.Enabled := (FPlayBackLevelNo <> 0) and (FRole.Playbacklist.Count > 0);
end;

procedure TMainForm.DrawStatusBox(S: string; TopOrCenter: Boolean);
var
  R       : TRect;
  TextSize: TSize;
begin
  with FBackBitmap, FBackBitmap.Canvas do
  begin
    Font.Color := clWhite; // r
    Font.name := 'FixedSys';
    Font.Style := [fsBold];
    Font.Size := 20;

    TextSize := TextExtent(S);
    // first calculate the necessary rectangle
    R := Rect(0, 0, TextSize.cx, TextSize.cy);
    OffsetRect(R, (Width - TextSize.cx) div 2, (Height - TextSize.cy) div 2); // Nخظme

    if TopOrCenter then
    begin
      R.Top := 20; // Nخ\bW褤
      R.Bottom := R.Top + TextSize.cy;
    end;

    InflateRect(R, 10, 10); // yø~, e׬ 10
    Pen.Width := 4;
    Pen.Color := clWhite;
    Pen.Style := psSolid;
    Brush.Color := clBlue;
    Brush.Style := bsSolid;
    Rectangle(R.Left, R.Top, R.Right, R.Bottom);
    // NreX, m
    DrawText(Canvas.Handle, PChar(S), Length(S), R, DT_CENTER or DT_SINGLELINE or DT_VCENTER);
  end;
end;

procedure TMainForm.mnuStartGameClick(Sender: TObject);
begin
  GameStatus := gsPlaying;
  LevelNo := 1;
end;

procedure TMainForm.mnuChooseLevelClick(Sender: TObject);
var
  S: string;
begin
  S := IntToStr(FLevelNo);
  if InputQuery(Application.Title, 'Input Level No:', S) then
  begin
    GameStatus := gsPlaying;
    LevelNo := StrToInt(S);
  end;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
    Shift: TShiftState);
begin
  if FGameStatus = gsPlaying then // `N, uCA, L~
  begin
    case Key of
      VK_UP: FRole.Move(drUp); // VW

      VK_DOWN: FRole.Move(drDown); // VU

      VK_LEFT: FRole.Move(drLeft); // V

      VK_RIGHT: FRole.Move(drRight); // Vk

      else Exit; // ë@q, z
    end;

    UpdateView; // se

    if CheckFinished then // O_ ??
    begin
      FRole.SavePlayBack; // NʰOs_ӥHK
      GameStatus := gsSuccess; // iJLA
    end;
  end;
end;

function TMainForm.CheckFinished: Boolean;
var
  X, Y: Integer;
begin
  // v@ˬdCӥتaάO_wQл\Ϊ~л\F ?
  for Y := 0 to TILE_NUM_Y - 1 do
    for X := 0 to TILE_NUM_X - 1 do
      if Map.IsTarget[X, Y] and not Map.IsSource[X, Y] then
      begin
        Result := False; // @, @ӥتa٨SQ,  !!
        Exit;
      end;

  Result := True; // Yeah, \F
end;

procedure TMainForm.mnuAboutClick(Sender: TObject);
begin
  with TAboutBox.Create(self) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TMainForm.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.mnuRestartClick(Sender: TObject);
begin
  LevelNo := LevelNo;
end;

procedure TMainForm.mnuNextLevelClick(Sender: TObject);
begin
  case (Sender as TComponent).Tag of
    0: LevelNo := LevelNo - 1;
    1: LevelNo := LevelNo + 1;
  end;
end;

procedure TMainForm.mnuPlaybackClick(Sender: TObject);
begin
  GameStatus := gsPlayback;
end;

procedure TMainForm.tmrTimerTimer(Sender: TObject);
begin
  Inc(FPlayingTime); // Ciɶ[@
  UpdateView; // jse
end;

procedure TMainForm.tmrTitleTimer(Sender: TObject);
begin
  FRole.Move(TDirection(Random(4))); // DN
  UpdateView; // se
end;

procedure TMainForm.tmrPlaybackTimer(Sender: TObject);
begin
  // Ӥeʧ@`Ǩ, ϥ tmrPlayback  Tag ݩʨӰOثeĴXB
  FRole.Move(TDirection(FRole.Playbacklist[tmrPlayback.Tag]));
  tmrPlayback.Tag := tmrPlayback.Tag + 1; // o@BLF, WܤU@B
  if tmrPlayback.Tag = FRole.Playbacklist.Count then // F, Le
    GameStatus := gsSuccess;
  UpdateView; // se
end;

initialization
  Randomize; // üƺؤl
  
end.

